/**
 * Created by andre on 23/11/14.
 *
 * Prepara ambiente de Migração
 *
 */

var CliBase = require('cli-base').cliBase,
    Migrate = require('../lib/migrate');

module.exports = Object.create(CliBase, {

    main: {
        value: function (argv) {
            "use strict";

            Migrate.configByArgv(argv);

            Migrate.init();

        }
    },

    getShortInfo: {
        value: function(){

            return "Cria uma nova estrutura de diretório para a ferramenta de migração. Por padrão 'data'";
        }
    },

    help: {
        value: function(){

            return this.getShortInfo();
        }
    },

    arguments: {
        value: function(){

            return {
                '--path': 'Local onde será criado a estrutura inicial, padrão: DIRETÓRIO ATUAL'

            }

        }
    }




});

