/**
 * Created by andre on 23/11/14.
 *
 * // TODO: Permitir especificar banco de dados aqui
 */



var CliBase = require('cli-base').cliBase,
    Migrate = require('../lib/migrate');

module.exports = Object.create(CliBase, {

    main: {
        value: function (argv) {
            "use strict";

            Migrate.configByArgv(argv);
            Migrate.runMigration(argv.v);


        }

    },
    help: {
        value: function () {


            return "Executa migração. Banco de dados será removido e recriado com a nova versão. Caso não seja uma nova migração, então os dados serão migrados da versão antiga\n" +
                "\tSerá realizado backup dos dados antes de migração";

        }
    },
    getShortInfo: {
        value: function () {

            return "Executa migração";

        }
    },
    arguments: {
        value: function () {

            return {
                '--path': 'Localização da estrutura de migração. Padrão: Diretório atual',
                '-v': 'Verboso'
            }


        }
    }
});